<?php
/**
 * Lights Store functions and definitions
 *
 * @package Lights Store
 */

if ( ! defined( 'LIGHT_STORE_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'LIGHT_STORE_VERSION', '1.0.0' );
}

function lights_store_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'lights-store' ),
			'social-menu' => esc_html__('Social Menu', 'lights-store'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'lights_store_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'lights_store_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $lights_store_content_width
 */
function lights_store_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'lights_store_content_width', 640 );
}
add_action( 'after_setup_theme', 'lights_store_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function lights_store_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'lights-store' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'lights-store' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'lights-store' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'lights-store' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'lights-store' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'lights-store' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'lights-store' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'lights-store' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'lights_store_widgets_init' );


function lights_store_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }


/**
 * Enqueue scripts and styles.
 */

function lights_store_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Caveat Brush|Montserrat:ital,wght@0,100..900;1,100..900'),
        'display' => 'swap',
    );
    wp_enqueue_style('lights-store-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('lights-store-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Check if custom styles exist before adding inline styles
    if (file_exists(get_parent_theme_file_path('/custom-style.php'))) {
        require get_parent_theme_file_path('/custom-style.php');

        if (!empty($lights_store_custom_css)) {
            wp_add_inline_style('lights-store-style', $lights_store_custom_css);
        }
    }

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('lights-store-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('lights-store-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Custom script
    wp_enqueue_script('lights-store-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'lights_store_scripts');

if (!function_exists('lights_store_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function lights_store_related_post($post_id){        
        $lights_store_categories = get_the_category($post_id);
        if ($lights_store_categories) {
            $lights_store_category_ids = array();
            $lights_store_category = get_category($lights_store_category_ids);
            $lights_store_categories = get_the_category($post_id);
            foreach ($lights_store_categories as $lights_store_category) {
                $lights_store_category_ids[] = $lights_store_category->term_id;
            }
            $lights_store_count = $lights_store_category->category_count;
            if ($lights_store_count > 1) { ?>

         	<?php
		$lights_store_related_post_wrap = absint(get_theme_mod('lights_store_enable_related_post', 1));
		if($lights_store_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('lights_store_related_post_text', __('Related Post', 'lights-store'))); ?></h2>
                    <?php
                    $lights_store_cat_post_args = array(
                        'category__in' => $lights_store_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'lights_store_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $lights_store_featured_query = new WP_Query($lights_store_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($lights_store_featured_query->have_posts()) :

                        while ($lights_store_featured_query->have_posts()) : $lights_store_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php lights_store_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $lights_store_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/about1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $lights_store_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        lights_store_posted_on();
                                        lights_store_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('lights_store_related_posts', 'lights_store_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$lights_store_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function lights_store_sanitize_checkbox($lights_store_checked)
{
    // Boolean check.
    return ((isset($lights_store_checked) && true == $lights_store_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function lights_store_enqueue_function() {

    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/lights_store_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/lights_store_config_file.php';


    define('LIGHT_STORE_FREE_SUPPORT',__('https://wordpress.org/support/theme/lights-store/','lights-store'));
    define('LIGHT_STORE_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','lights-store'));
    define('LIGHT_STORE_REVIEW',__('https://wordpress.org/support/theme/lights-store/reviews/#new-post','lights-store'));
    define('LIGHT_STORE_BUY_NOW',__('https://www.revolutionwp.com/products/lights-wordpress-theme','lights-store'));
    define('LIGHT_STORE_LIVE_DEMO',__('https://demo.revolutionwp.com/lights-store-pro/','lights-store'));
    define('LIGHT_STORE_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/lights-store-pro/','lights-store'));
    define('LIGHT_STORE_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/lights-store-free/','lights-store'));

}
add_action( 'after_setup_theme', 'lights_store_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function lights_store_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'lights_store_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'lights_store_loop_columns');

if (!function_exists('lights_store_loop_columns')) {

	function lights_store_loop_columns() {

		$lights_store_columns = get_theme_mod( 'lights_store_per_columns', 3 );

		return $lights_store_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'lights_store_per_page', 20 );

function lights_store_per_page( $lights_store_cols ) {

  	$lights_store_cols = get_theme_mod( 'lights_store_product_per_page', 9 );

	return $lights_store_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'lights_store_products_args' );

function lights_store_products_args( $lights_store_args ) {

    $lights_store_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $lights_store_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $lights_store_args;
}

/************************************************************************************/


/**
 * Custom logo
 */

function lights_store_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --lights_store_logo_width: <?php echo absint(get_theme_mod('lights_store_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('lights_store_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'lights_store_custom_css' );

function lights_store_sanitize_choices( $lights_store_input, $lights_store_setting ) {
    global $wp_customize; 
    $lights_store_control = $wp_customize->get_control( $lights_store_setting->id ); 
    if ( array_key_exists( $lights_store_input, $lights_store_control->choices ) ) {
        return $lights_store_input;
    } else {
        return $lights_store_setting->default;
    }
}

//Excerpt 
function lights_store_excerpt_function($lights_store_excerpt_count = 35) {
    $lights_store_excerpt = get_the_excerpt();
    $lights_store_text_excerpt = wp_strip_all_tags($lights_store_excerpt);
    $lights_store_excerpt_limit = (int) get_theme_mod('lights_store_excerpt_limit', $lights_store_excerpt_count);
    $lights_store_words = preg_split('/\s+/', $lights_store_text_excerpt); 
    $lights_store_trimmed_words = array_slice($lights_store_words, 0, $lights_store_excerpt_limit);
    $lights_store_theme_excerpt = implode(' ', $lights_store_trimmed_words);

    return $lights_store_theme_excerpt;
}

function lights_store_sanitize_dropdown_pages( $lights_store_page_id, $lights_store_setting ) {
  // Ensure $lights_store_input is an absolute integer.
  $lights_store_page_id = absint( $lights_store_page_id );
  // If $lights_store_page_id is an ID of a published page, return it; otherwise, return the default.
  return ( 'publish' == get_post_status( $lights_store_page_id ) ? $lights_store_page_id : $lights_store_setting->default );
}

// Add admin notice
function lights_store_admin_notice() { 
    global $pagenow;
    $lights_store_theme_args      = wp_get_theme();
    $lights_store_meta            = get_option( 'lights_store_admin_notice' );
    $name            = $lights_store_theme_args->__get( 'Name' );
    $lights_store_current_screen  = get_current_screen();

    if( !$lights_store_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $lights_store_current_screen->base !== 'appearance_page_lights_store_guide' && 
            $lights_store_current_screen->base !== 'toplevel_page_lightsstore-demoimport' ) { ?>

            <div class="notice notice-success lights-store-welcome-notice">
                <p class="lights-store-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'lights_store_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'lights-store' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="lights-store-welcome-notice-wrap">
                    <h2 class="lights-store-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $lights_store_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'lights-store' ), $lights_store_theme_name ) );
                        ?>
                    </h2>
                    <p class="lights-store-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'lights-store' ); ?>
                    </p>

                    <div class="lights-store-welcome-info">
                        <div class="lights-store-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'lights-store' ); ?>">
                        </div>

                        <div class="lights-store-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'lights-store' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'lights-store' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=lightsstore-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'lights-store' ); ?></a></p>
                        </div>

                        <div class="lights-store-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'lights-store' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'lights-store' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=lights-store-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'lights-store' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'lights_store_admin_notice' );

if( ! function_exists( 'lights_store_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function lights_store_update_admin_notice(){
    if ( isset( $_GET['lights_store_admin_notice'] ) && $_GET['lights_store_admin_notice'] = '1' ) {
        update_option( 'lights_store_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'lights_store_update_admin_notice' );


add_action('after_switch_theme', 'lights_store_setup_options');
function lights_store_setup_options () {
    update_option('lights_store_admin_notice', FALSE );
}

// changelog
function get_changelog_from_readme() {
    $lights_store_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($lights_store_file_path)) {
        $lights_store_content = file_get_contents($lights_store_file_path);

        // Extract changelog section
        $lights_store_changelog_start = strpos($lights_store_content, "== Changelog ==");
        $lights_store_changelog = substr($lights_store_content, $lights_store_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $lights_store_changelog, $lights_store_matches, PREG_SET_ORDER);
        
        return $lights_store_matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );